%global with_check 0

%global _find_debuginfo_dwz_opts %{nil}
%global _dwz_low_mem_die_limit 0

%if 0%{?rhel} > 7 && ! 0%{?fedora}
%define gobuild(o:) \
go build -buildmode pie -compiler gc -tags="rpm_crashtraceback libtrust_openssl ${BUILDTAGS:-}" -ldflags "${LDFLAGS:-} -linkmode=external -compressdwarf=false -B 0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \\n') -extldflags '%__global_ldflags'" -a -v %{?**};
%else
%if ! 0%{?gobuild:1}
%define gobuild(o:) GO111MODULE=off go build -buildmode pie -compiler gc -tags="rpm_crashtraceback ${BUILDTAGS:-}" -ldflags "${LDFLAGS:-} -linkmode=external -B 0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \\n') -extldflags '-Wl,-z,relro -Wl,-z,now -specs=/usr/lib/rpm/redhat/redhat-hardened-ld '" -a -v %{?**};
%endif
%endif

%global provider github
%global provider_tld com
%global project opencontainers
%global repo runc
# https://github.com/opencontainers/runc
%global import_path %{provider}.%{provider_tld}/%{project}/%{repo}
%global git0 https://%{import_path}

Epoch: 3
Name: %{repo}
Version: 1.1.0
Release: 1.rhaos4.10%{?dist}
Summary: CLI for running Open Containers
# https://fedoraproject.org/wiki/PackagingDrafts/Go#Go_Language_Architectures
#ExclusiveArch: %%{go_arches}
# still use arch exclude as the macro above still refers %%{ix86} in RHEL8.4:
# https://bugzilla.redhat.com/show_bug.cgi?id=1905383
ExcludeArch: %{ix86}
License: ASL 2.0
URL: %{git0}
Source0: %{git0}/archive/v%{version}.tar.gz
Provides: oci-runtime
BuildRequires: golang >= 1.12.12-4
BuildRequires: git
BuildRequires: go-md2man
BuildRequires: libseccomp-devel
Requires: criu

%description
The runc command can be used to start containers which are packaged
in accordance with the Open Container Initiative's specifications,
and to manage containers running under runc.

%prep
%autosetup -Sgit
sed -i '/\#\!\/bin\/bash/d' contrib/completions/bash/%{name}

%build
mkdir -p GOPATH
pushd GOPATH
    mkdir -p src/%{provider}.%{provider_tld}/%{project}
    ln -s $(dirs +1 -l) src/%{import_path}
popd

pushd GOPATH/src/%{import_path}
export GO111MODULE=off
export GOPATH=%{gopath}:$(pwd)/GOPATH
export CGO_CFLAGS="%{optflags} -D_GNU_SOURCE -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64"
export BUILDTAGS="selinux seccomp"
export LDFLAGS="-X main.gitCommit= -X main.version=%{version}"
%gobuild -o %{name} %{import_path}

pushd man
./md2man-all.sh
popd

%install
make install install-man install-bash DESTDIR=$RPM_BUILD_ROOT PREFIX=%{_prefix} LIBDIR=%{_libdir} BINDIR=%{_bindir}

%check

#define license tag if not already defined
%{!?_licensedir:%global license %doc}

%files
%license LICENSE
%doc MAINTAINERS_GUIDE.md PRINCIPLES.md README.md CONTRIBUTING.md
%{_bindir}/%{name}
%{_mandir}/man8/%{name}*
%{_datadir}/bash-completion/completions/%{name}

%changelog
* Thu Feb 03 2022 Jindrich Novy <jnovy@redhat.com> - 3:1.1.0-1.rhaos4.10
- update runc to 1.1.0 (requested by Mrunal Patel - showed significant
  gains in reducing exec overhead)
- Related: #2000051

* Wed Jan 26 2022 Jindrich Novy <jnovy@redhat.com> - 1.0.1-3.rhaos4.10
- update at least to RHAOS-4.9 version to preserve upgrade path

* Wed Jan 26 2022 Jindrich Novy <jnovy@redhat.com> - 1.0.0-1.rhaos4.10
- revert to the state of 3.0-8.4.0 release (requested by Micah Abbott)

* Tue Jan 25 2022 Jindrich Novy <jnovy@redhat.com> - 1.0.2-3.rhaos4.10
- revert to the state of 8.5.0 GA - requested by Micah Abbott

* Tue Jan 18 2022 Jindrich Novy <jnovy@redhat.com> - 1.1.0-0.rhaos4.10.2
- update to https://github.com/opencontainers/runc/releases/tag/v1.1.0
- Related: #2001445

* Wed Dec 22 2021 Jindrich Novy <jnovy@redhat.com> - 1.0.3-0.rhaos4.10.1
- update to https://github.com/opencontainers/runc/releases/tag/v1.0.3
- Related: #2001445

* Mon Nov 22 2021 Jindrich Novy <jnovy@redhat.com> - 1.0.2-2.rhaos4.10
- fix release

* Mon Nov 22 2021 Jindrich Novy <jnovy@redhat.com> - 1.0.2-0.rhaos4.10
- update to https://github.com/opencontainers/runc/releases/tag/v1.0.2
- Related: #1934415

* Mon Nov 01 2021 Peter Hunt <pehunt@redhat.com> - 1.0.1-3.rhaos4.10.git4144b63
- initial 4.10 build

* Thu Jul 22 2021 Peter Hunt <pehunt@redhat.com> - 1.0.1-2.rhaos4.9.git4144b63
- bump to v1.0.1

* Wed Jun 30 2021 Peter Hunt <pehunt@redhat.com> - 1.0.0-1.rhaos4.9.gitcd80260
- initial 4.9 build
